package com.jsonpfy.operations;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import com.google.appengine.api.datastore.DatastoreService;
import com.google.appengine.api.datastore.DatastoreServiceFactory;
import com.google.appengine.api.datastore.Entity;
import com.google.appengine.api.datastore.Key;
import com.google.appengine.api.datastore.KeyFactory;
import com.jsonpfy.utilities.JsonpfyProperties;

/**
 * 
 * @Feature
 */
public class SaveArrayData {

	public static final String OPERATION_ADD = "ADD";
	public static final String OPERATION_DELETE = "DELETE";
	public static final String OPERATION_SAVE = "SAVE";

	public static void doPut(Map<String, String[]> entityMap,
			final String operation) {

		String kind = entityMap.get(JsonpfyProperties.ENTITY_KIND)[0];

		String ID = entityMap.get(JsonpfyProperties.ENTITY_ID)[0];
		
		String KeyKind = entityMap.get(JsonpfyProperties.ENTITY_KEY_KIND)[0];

		Entity entity = GetData.getEntity(kind, ID);

		if (entity != null) {

			DatastoreService datastore = DatastoreServiceFactory
					.getDatastoreService();

			for (Entry<String, String[]> mapEntry : entityMap.entrySet()) {

				String parameter = mapEntry.getKey();

				String[] values = mapEntry.getValue();

				if (!JsonpfyProperties.ENTITY_KIND.equals(parameter)
						&& !JsonpfyProperties.ENTITY_ID.equals(parameter)
						&& !JsonpfyProperties.ENTITY_KEY_KIND.equals(parameter)) {

					ArrayList<Key> arrayKey = new ArrayList<Key>();

					if (OPERATION_ADD.equals(operation)
							|| OPERATION_DELETE.equals(operation)) {

						getExistingValues(arrayKey, entity, parameter,
								operation, KeyKind, values);
					}

					if (!OPERATION_DELETE.equals(operation)) {

						for (String stringValue : values) {

							if (!stringValue.equals("")) {

								Key key = KeyFactory.createKey(KeyKind,
										stringValue);

								arrayKey.add(key);
							}
						}
					}

					entity.setProperty(parameter, arrayKey);
				}
			}

			datastore.put(entity);
		}
	}

	private static void getExistingValues(List<Key> arrayKey, Entity entity,
			String parameter, String operation, String KeyKind, String[] values) {

		ArrayList<Key> parameterList = (ArrayList<Key>) entity
				.getProperty(parameter);

		if (parameterList != null) {

			for (Key entityKeyValue : parameterList) {

				if (OPERATION_DELETE.equals(operation)) {

					for (String stringValue : values) {

						if (!stringValue.equals("")) {

							Key key = KeyFactory.createKey(KeyKind, stringValue);

							if (!entityKeyValue.getName().equals(key.getName())) {

								arrayKey.add(entityKeyValue);
							}
						}
					}

				} else {

					arrayKey.add(entityKeyValue);
				}
			}
		}
	}
}