package com.jsonpfy.webservices;

import java.io.IOException;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.json.JSONObject;

import com.jsonpfy.operations.GetData;
import com.jsonpfy.utilities.CallbackUtilities;
import com.jsonpfy.utilities.JsonpfyProperties;
import com.jsonpfy.utilities.URLUtilities;

@SuppressWarnings("serial")
public class GetDataServlet extends HttpServlet {

	public void doGet(HttpServletRequest request, HttpServletResponse response)
			throws IOException {

		if (JsonpfyProperties.OPEN) {

			response.getWriter().println(getData(request));
		}
	}

	public void doPost(HttpServletRequest request, HttpServletResponse response)
			throws IOException {

		response.getWriter().println(getData(request));
	}

	private String getData(HttpServletRequest request) {

		String answer = null;

		if (JsonpfyProperties.OPEN || JsonpfyProperties.authenticate(request)) {

			String kind = URLUtilities.decode(request
					.getParameter(JsonpfyProperties.ENTITY_KIND));

			String keyValue = URLUtilities.decode(request
					.getParameter(JsonpfyProperties.ENTITY_ID));

			JSONObject entity = new JSONObject();
			try {
				entity = GetData.getJson(kind, Long.parseLong(keyValue));
				
			} catch (NumberFormatException nfe) {
				entity = GetData.getJson(kind, keyValue);
			}

			answer = CallbackUtilities.getCallback(
					request.getParameter("callback"), entity.toString());
		}

		return answer;
	}
}
