package com.jsonpfy.webservices;

import java.io.IOException;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.json.JSONArray;

import com.jsonpfy.operations.ListSubArray;
import com.jsonpfy.utilities.CallbackUtilities;
import com.jsonpfy.utilities.JsonpfyProperties;
import com.jsonpfy.utilities.URLUtilities;

@SuppressWarnings("serial")
public class ListSubArrayServlet extends HttpServlet {

	// http://localhost:8888/ListSubArrayService
	// ?kind=Entity
	// &ID=goLiveSource
	// &fieldSubArray=groupConnections

	public void doGet(HttpServletRequest request, HttpServletResponse response)
			throws IOException {

		if (JsonpfyProperties.OPEN) {

			response.getWriter().println(listData(request));
		}
	}

	public void doPost(HttpServletRequest request, HttpServletResponse response)
			throws IOException {

		response.getWriter().println(listData(request));
	}

	private String listData(HttpServletRequest request) {

		String answer = null;

		if (JsonpfyProperties.OPEN || JsonpfyProperties.authenticate(request)) {

			JSONArray entities = null;

			String kind = URLUtilities.decode(request
					.getParameter(JsonpfyProperties.ENTITY_KIND));

			String ID = URLUtilities.decode(request
					.getParameter(JsonpfyProperties.ENTITY_ID));

			String fieldSubArray = URLUtilities.decode(request
					.getParameter("fieldSubArray"));

			entities = ListSubArray.jsonList(kind, ID, fieldSubArray);

			answer = CallbackUtilities.getCallback(
					request.getParameter("callback"), entities.toString());
		}

		return answer;
	}

}
