package com.jsonpfy.webservices;

import java.io.IOException;
import java.util.Map;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.jsonpfy.operations.SaveArrayData;
import com.jsonpfy.utilities.CallbackUtilities;
import com.jsonpfy.utilities.JsonpfyProperties;

@SuppressWarnings("serial")
public class SaveArrayDataServlet extends HttpServlet {

	// http://localhost:8888/SaveArrayDataService
	// ?kind=Entity&ID=goLiveSource
	// &groupConnections=LiveSourceWeb

	public void doGet(HttpServletRequest request, HttpServletResponse response)
			throws IOException {

		if (JsonpfyProperties.OPEN) {

			response.getWriter().println(saveArrayData(request));
		}
	}

	public void doPost(HttpServletRequest request, HttpServletResponse response)
			throws IOException {

		response.getWriter().println(saveArrayData(request));
	}

	private String saveArrayData(HttpServletRequest request) {

		String answer = null;

		if (JsonpfyProperties.OPEN || JsonpfyProperties.authenticate(request)) {

			Map<String, String[]> parameters = request.getParameterMap();

			SaveArrayData.doPut(parameters, SaveArrayData.OPERATION_SAVE);

			answer = CallbackUtilities.getCallback(
					request.getParameter("callback"), "OK");
		}
		return answer;
	}
}
